/**
 * @file
 * This header file declares the function to create one instance of the CrIaCalFullSnap procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaCalFullSnap.png
 *
 * @author FW Profile code generator version 5.01
 * @date Created on: Jul 16 2018 16:41:41
 */

/** Make sure to include this header file only once */
#ifndef CrIaCalFullSnapCreate_H_
#define CrIaCalFullSnapCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaCalFullSnap_N1 (1)		/* The identifier of action node N1 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N2 (2)		/* The identifier of action node N2 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N2_1 (3)		/* The identifier of action node N2_1 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N3 (4)		/* The identifier of action node N3 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N4 (5)		/* The identifier of action node N4 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N5 (6)		/* The identifier of action node N5 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N5_1 (7)		/* The identifier of action node N5_1 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N5_2 (8)		/* The identifier of action node N5_2 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N6 (9)		/* The identifier of action node N6 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N7 (10)		/* The identifier of action node N7 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N8 (11)		/* The identifier of action node N8 in procedure CrIaCalFullSnap */
#define CrIaCalFullSnap_N9 (12)		/* The identifier of action node N9 in procedure CrIaCalFullSnap */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaCalFullSnapCreate(void* prData);

/**
 * Action for node N4.
 * Send cmd (220,11) to the SEM
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN4(FwPrDesc_t prDesc);

/**
 * Action for node N1.
 * Generate Event Report EVT_SC_PR_STRT
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN1(FwPrDesc_t prDesc);

/**
 * Action for node N8.
 * <pre>
 * Stop Compression/Collection
 * and Centroid Algorithms
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN8(FwPrDesc_t prDesc);

/**
 * Action for node N6.
 * <pre>
 * Start Compression/Collection
 * Algorithm
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN6(FwPrDesc_t prDesc);

/**
 * Action for node N9.
 * <pre>
 * Generate Event Report EVT_SC_PR_END
 *  with outcome equal to: "success"
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN9(FwPrDesc_t prDesc);

/**
 * Action for node N7.
 * <pre>
 * Send command GoToStabilize
 * to SEM Unit State Machine
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN7(FwPrDesc_t prDesc);

/**
 * Action for node N2.
 * <pre>
 * Update SEM configuration
 * parameters in the data pool
 * with procedure parameters
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN2(FwPrDesc_t prDesc);

/**
 * Action for node N3.
 * Send cmd (220,3) to the SEM
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN3(FwPrDesc_t prDesc);

/**
 * Action for node N2_1.
 * <pre>
 * Set data pool variable
 * pCcdRdMode to CCD_FULL
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN2_1(FwPrDesc_t prDesc);

/**
 * Action for node N5_1.
 * <pre>
 * Enable the selected
 * centroiding algorithm
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN5_1(FwPrDesc_t prDesc);

/**
 * Action for node N5_2.
 * Start Centroiding Algorithms
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN5_2(FwPrDesc_t prDesc);

/**
 * Action for node N5.
 * <pre>
 * Send command GoToCcdFull
 * to SEM Unit State Machine
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCalFullSnapN5(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N4 to N5.
 * <pre>
 *  Wait calFullSnapT2
 * cycles 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaCalFullSnapWaitT2(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N1 to N2.
 *  SEM State Machine is in STABILIZE 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaCalFullSnapIsSemInStab(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N6 to N7.
 *  Flag_1  
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaCalFullSnapFlag1And2(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N7 to N8.
 * <pre>
 *  (SEM Operational SM is in STABILIZE) &&
 * (All sporadic activities have terminated) 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaCalFullSnapIsTerm(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N3 to N4.
 * <pre>
 *  Wait calFullSnapT1
 * cycles 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaCalFullSnapWaitT1(FwPrDesc_t prDesc);

#endif /* CrIaCalFullSnapCreate_H_ */
