/**
 * @file
 * This header file declares the function to create one instance of the CrIaCentAlgo procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaCentAlgo.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Feb 11 2016 22:56:45
 */

/** Make sure to include this header file only once */
#ifndef CrIaCentAlgoCreate_H_
#define CrIaCentAlgoCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaCentAlgo_N1 1		/* The identifier of action node N1 in procedure CrIaCentAlgo */
#define CrIaCentAlgo_N2 2		/* The identifier of action node N2 in procedure CrIaCentAlgo */
#define CrIaCentAlgo_N4 3		/* The identifier of action node N4 in procedure CrIaCentAlgo */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaCentAlgoCreate(void* prData);

/**
 * Action for node N1.
 * <pre>
 * Select the SIB to be used as input
 * for the Centroiding Algorithm
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCentAlgoN1(FwPrDesc_t prDesc);

/**
 * Action for node N2.
 * <pre>
 * Compute centroiding data
 * for data in the selected input buffer 
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCentAlgoN2(FwPrDesc_t prDesc);

/**
 * Action for node N4.
 * Write algorithm output to the data pool
 * @param smDesc the procedure descriptor
 */
void CrIaCentAlgoN4(FwPrDesc_t prDesc);

#endif /* CrIaCentAlgoCreate_H_ */