/**
 * @file
 * This header file declares the function to create one instance of the CrIaCmprAlgoExec procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaCmprAlgoExec.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Sep 21 2016 11:3:28
 */

/** Make sure to include this header file only once */
#ifndef CrIaCmprAlgoExecCreate_H_
#define CrIaCmprAlgoExecCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaCmprAlgoExec_N1 1		/* The identifier of action node N1 in procedure CrIaCmprAlgoExec */
#define CrIaCmprAlgoExec_N2 2		/* The identifier of action node N2 in procedure CrIaCmprAlgoExec */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaCmprAlgoExecCreate(void* prData);

/** Action for node N1. */
void CrIaCmprAlgoExecN1(FwPrDesc_t __attribute__((unused)) prDesc);

/** Action for node N2. */
void CrIaCmprAlgoExecN2(FwPrDesc_t __attribute__((unused)) prDesc);

/** Guard on the Control Flow from N1 to N2. */
FwPrBool_t CrIaCmprAlgoExecGuard(FwPrDesc_t __attribute__((unused)) prDesc);

#endif /* CrIaCmprAlgoExecCreate_H_ */
