/**
 * @file
 * This header file declares the function to create one instance of the CrIaNomSci procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaNomSci.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Jun 3 2016 19:48:5
 */

/** Make sure to include this header file only once */
#ifndef CrIaNomSciCreate_H_
#define CrIaNomSciCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaNomSci_N1 (1)		/* The identifier of action node N1 in procedure CrIaNomSci */
#define CrIaNomSci_N2 (2)		/* The identifier of action node N2 in procedure CrIaNomSci */
#define CrIaNomSci_N3 (3)		/* The identifier of action node N3 in procedure CrIaNomSci */
#define CrIaNomSci_N4 (4)		/* The identifier of action node N4 in procedure CrIaNomSci */
#define CrIaNomSci_N5 (5)		/* The identifier of action node N5 in procedure CrIaNomSci */
#define CrIaNomSci_N5_1 (6)		/* The identifier of action node N5_1 in procedure CrIaNomSci */
#define CrIaNomSci_N6 (7)		/* The identifier of action node N6 in procedure CrIaNomSci */
#define CrIaNomSci_N7 (8)		/* The identifier of action node N7 in procedure CrIaNomSci */
#define CrIaNomSci_N7_1 (9)		/* The identifier of action node N7_1 in procedure CrIaNomSci */
#define CrIaNomSci_N8 (10)		/* The identifier of action node N8 in procedure CrIaNomSci */
#define CrIaNomSci_N9 (11)		/* The identifier of action node N9 in procedure CrIaNomSci */
#define CrIaNomSci_N9_1 (12)		/* The identifier of action node N9_1 in procedure CrIaNomSci */
#define CrIaNomSci_N10 (13)		/* The identifier of action node N10 in procedure CrIaNomSci */
#define CrIaNomSci_N11 (14)		/* The identifier of action node N11 in procedure CrIaNomSci */
#define CrIaNomSci_N11_1 (15)		/* The identifier of action node N11_1 in procedure CrIaNomSci */
#define CrIaNomSci_N12 (16)		/* The identifier of action node N12 in procedure CrIaNomSci */
#define CrIaNomSci_N13 (17)		/* The identifier of action node N13 in procedure CrIaNomSci */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaNomSciCreate(void* prData);

/**
 * Action for node N2.
 * <pre>
 * Set SDB parameters according
 * to procedure parameters
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN2(FwPrDesc_t prDesc);

/**
 * Action for node N3.
 * <pre>
 * Configure SDB for
 * operation in Full CCD Mode
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN3(FwPrDesc_t prDesc);

/**
 * Action for node N1.
 * <pre>
 * Generate event report
 * EVT_SC_PR_STRT
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN1(FwPrDesc_t prDesc);

/**
 * Action for node N5.
 * <pre>
 * Start procedure
 * Acquire Full Drop
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN5(FwPrDesc_t prDesc);

/**
 * Action for node N6.
 * <pre>
 * Send ResetFull cmd
 * to SDB State Machine
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciSdbResetFull(FwPrDesc_t prDesc);

/**
 * Action for node N7.
 * <pre>
 * Start procedure
 * Calibrate Full Snap
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN7(FwPrDesc_t prDesc);

/**
 * Action for node N9.
 * <pre>
 * Start procedure
 * Science Window Stack/Snap
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN9(FwPrDesc_t prDesc);

/**
 * Action for node N7_1.
 * <pre>
 * Set STCK_ORDER
 * equal to pStckOrderSci
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN7_1(FwPrDesc_t prDesc);

/**
 * Action for node N11_1.
 * Stop Save Images Proc.
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN11_1(FwPrDesc_t prDesc);

/**
 * Action for node N9_1.
 * <pre>
 * Set STCK_ORDER
 * equal to pStckOrderCal2
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN9_1(FwPrDesc_t prDesc);

/**
 * Action for node N11.
 * <pre>
 * Start procedure
 * Calibrate Full Snap
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN11(FwPrDesc_t prDesc);

/**
 * Action for node N4.
 * Start Save Images Procedure
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN4(FwPrDesc_t prDesc);

/**
 * Action for node N5_1.
 * <pre>
 * Set STCK_ORDER
 * equal to pStckOrderCal1
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN5_1(FwPrDesc_t prDesc);

/**
 * Action for node N8.
 * <pre>
 * Send ResetWin cmd
 * to SDB State Machine
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN8(FwPrDesc_t prDesc);

/**
 * Action for node N12.
 * Generate event report EVT_SC_PR_END with outcome "success"
 * @param smDesc the procedure descriptor
 */
void CrIaNomSciN12(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION2 to N5.
 *  pAcqFlag == TRUE 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaNomSciIsAcqFlagTrue(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N5 to DECISION3.
 * <pre>
 *  (Acquire Full Drop Proc.
 * has terminated) 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaNomSciIsN5Finished(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION3 to N5_1.
 *  pCal1Flag == TRUE 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaNomSciIsCal1FlagTrue(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N7 to DECISION4.
 * <pre>
 *  (Calibrate Full Snap Proc.
 * has terminated) 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaNomSciIsN7Finished(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION4 to N7_1.
 *  pSciFlag == TRUE 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaNomSciIsSciFlagTrue(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N9 to DECISION5.
 * <pre>
 *  (Science Window Stack/Snap
 * Proc. has terminated) 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaNomSciIsN9Finished(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION5 to N9_1.
 *  pCal2Flag == TRUE 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaNomSciIsCal2FlagTrue(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N11 to N11_1.
 * <pre>
 *  (Calibrate Full Snap Proc.
 * has terminated) && Flag_1 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaNomSciIsN11Finished(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N13 to N11_1.
 *  Flag_1 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaNomSciIsFlag1True(FwPrDesc_t prDesc);

#endif /* CrIaNomSciCreate_H_ */
