/**
 * @file
 * This header file declares the function to create one instance of the CrIaPrepSci procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaPrepSci.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Feb 11 2016 22:56:46
 */

/** Make sure to include this header file only once */
#ifndef CrIaPrepSciCreate_H_
#define CrIaPrepSciCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaPrepSci_PREPSC1 1		/* The identifier of action node PREPSC1 in procedure CrIaPrepSci */
#define CrIaPrepSci_PREPSC2 2		/* The identifier of action node PREPSC2 in procedure CrIaPrepSci */
#define CrIaPrepSci_PREPSC3 3		/* The identifier of action node PREPSC3 in procedure CrIaPrepSci */
#define CrIaPrepSci_PREPSC4 4		/* The identifier of action node PREPSC4 in procedure CrIaPrepSci */
#define CrIaPrepSci_PREPSC5 5		/* The identifier of action node PREPSC5 in procedure CrIaPrepSci */
#define CrIaPrepSci_PREPSC6 6		/* The identifier of action node PREPSC6 in procedure CrIaPrepSci */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaPrepSciCreate(void* prData);

/**
 * Action for node PREPSC1.
 * <pre>
 * Send SwitchOff
 * Command to SEM Unit SM
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaPrepSciSwitchOff(FwPrDesc_t prDesc);

/**
 * Action for node PREPSC2.
 * <pre>
 * Send SwitchOn
 * Command to SEM Unit SM
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaPrepSciSwitchOn(FwPrDesc_t prDesc);

/**
 * Action for node PREPSC3 and PREPSC6.
 * <pre>
 * Send GoToStabilize
 * Command to SEM Unit SM
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaPrepSciGoToStab(FwPrDesc_t prDesc);

/**
 * Action for node PREPSC5.
 * Generate EVT_SEM_ILL_ST with SEM
 * Unit SM and SEM Operational SM states as parameters
 * @param smDesc the procedure descriptor
 */
void CrIaPrepSciGenEvt(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to PREPSC1.
 *  SEM Unit SM is in OFF  
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaPrepSciIsOff(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to PREPSC4.
 * <pre>
 *  SEM Operational SM is in STABILIZE 
 * or Higher State 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaPrepSciIsInStabOrHigher(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from PREPSC2 to PREPSC3.
 *  SEM Unit SM is in STANDBY 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaPrepSciIsInStandBy(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from PREPSC3 to Final Node.
 *  SEM Unit SM is in STABILIZE 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaPrepSciIsInStab(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from PREPSC4 to PREPSC6.
 * <pre>
 *  SEM Operational SM is in
 * non-transitory state 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIsPrepSciIsNonTransState(FwPrDesc_t prDesc);

#endif /* CrIaPrepSciCreate_H_ */
