/**
 * @file
 * This header file declares the function to create one instance of the CrIaSaveImages procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaSaveImages.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Feb 11 2016 22:56:45
 */

/** Make sure to include this header file only once */
#ifndef CrIaSaveImagesCreate_H_
#define CrIaSaveImagesCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaSaveImages_N1 1		/* The identifier of action node N1 in procedure CrIaSaveImages */
#define CrIaSaveImages_N2 2		/* The identifier of action node N2 in procedure CrIaSaveImages */
#define CrIaSaveImages_N3 3		/* The identifier of action node N3 in procedure CrIaSaveImages */
#define CrIaSaveImages_N4 4		/* The identifier of action node N4 in procedure CrIaSaveImages */
#define CrIaSaveImages_N5 5		/* The identifier of action node N5 in procedure CrIaSaveImages */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaSaveImagesCreate(void* prData);

/**
 * Action for node N2.
 * Set gibOut to point to oldest GIB
 * @param smDesc the procedure descriptor
 */
void CrIaSaveImagesN2(FwPrDesc_t prDesc);

/**
 * Action for node N3.
 * Start Down-Transfer of GIB
 * @param smDesc the procedure descriptor
 */
void CrIaSaveImagesN3(FwPrDesc_t prDesc);

/**
 * Action for node N4.
 * Increment gibOut
 * @param smDesc the procedure descriptor
 */
void CrIaSaveImagesN4(FwPrDesc_t prDesc);

/**
 * Action for node N1.
 * <pre>
 * Generate event report
 * EVT_SC_PR_STRT
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSaveImagesN1(FwPrDesc_t prDesc);

/**
 * Action for node N5.
 * <pre>
 * Start FBF Save Procedure
 * to transfer GIB pointed at by 
 * gibOut to flash memory
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSaveImagesN5(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N2 to DECISION1.
 *  gibIn != gibOut 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSaveImageGibInDiffGibOut(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N3 to N4.
 *  Flag_1 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSaveImagesFlag1(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to N3.
 *  pSaveTarget == GROUND 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSaveImagesTrgIsGrd(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N5 to N4.
 *  Flag_2 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSaveImagesFlag2(FwPrDesc_t prDesc);

#endif /* CrIaSaveImagesCreate_H_ */