/**
 * @file
 * This header file declares the function to create one instance of the CrIaSdsEvalAlgoExec procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 *
 * <b>Note for Control Flow from N1 to DECISION1</b>
 * This guard returns true if the Node Execution Counter 
 * (as returned by FwPrGetNodeExecCnt) is equal to 1.
 *
 * @image html CrIaSdsEvalAlgoExec.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Feb 11 2016 22:56:45
 */

/** Make sure to include this header file only once */
#ifndef CrIaSdsEvalAlgoExecCreate_H_
#define CrIaSdsEvalAlgoExecCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaSdsEvalAlgoExec_N1 1		/* The identifier of action node N1 in procedure CrIaSdsEvalAlgoExec */
#define CrIaSdsEvalAlgoExec_N2 2		/* The identifier of action node N2 in procedure CrIaSdsEvalAlgoExec */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaSdsEvalAlgoExecCreate(void* prData);

/**
 * Action for node N1.
 * isSdsActive = TRUE
 * @param smDesc the procedure descriptor
 */
void CrIaSdsEvalAlgoExecSetSdsActive(FwPrDesc_t prDesc);

/**
 * Action for node N2.
 * isSdsActive = FALSE
 * @param smDesc the procedure descriptor
 */
void CrIaSdsEvalAlgoExecSetSdsInactive(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to N1.
 *  SDS_FORCED && !SDS_INHIBITED 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSdsEvalAlgoExecC1(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to N2.
 *  !SDS_FORCED && SDS_INHIBITED 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSdsEvalAlgoExecC2(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N1 to DECISION1.
 *  Next Execution 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSdsEvalAlgoExecIsNextExec(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION2 to N1.
 *  isSaaActive || EARTH_OCCULT_ACTIVE 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSdsEvalAlgoExecC3(FwPrDesc_t prDesc);

#endif /* CrIaSdsEvalAlgoExecCreate_H_ */