/**
 * @file CrIaSemEvents.c
 *
 * @author UVIE
 * @date Created on: Nov 18 2015
 */

#include <CrIaSemEvents.h>

unsigned char CRSEM_SERV5_EVENT_PRG_PBS_BOOT_READY_SET;
unsigned char CRSEM_SERV5_EVENT_PRG_APS_BOOT_READY_SET;			
unsigned char CRSEM_SERV5_EVENT_PRG_MODE_TRANSITION_SET;		
unsigned char CRSEM_SERV5_EVENT_PRG_DIAGNOSE_STEP_FINISHED_SET;		
unsigned char CRSEM_SERV5_EVENT_PRG_THERMAL_STABILITY_SET;		
unsigned char CRSEM_SERV5_EVENT_PRG_CFG_LOAD_READY_SET;			
unsigned char CRSEM_SERV5_EVENT_PRG_FPA_TEMP_NOMINAL_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_EEPROM_NO_SEGMENT_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_EEPROM_NO_APS_EXE_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_EEPROM_NO_APS_CFG_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_EEPROM_NO_PBS_CFG_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_EEPROM_NO_APS_EXE_FLAG_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_EEPROM_NO_APS_CFG_FLAG_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_NO_THERMAL_STABILITY_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_FPA_TEMP_TOO_HIGH_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_WRONG_EXPOSURE_TIME_SET;		
unsigned char CRSEM_SERV5_EVENT_WAR_WRONG_REPETITION_PERIOD_SET;
unsigned char CRSEM_SERV5_EVENT_WAR_FPM_OFF_ONLY_PATTERN_SET;
unsigned char CRSEM_SERV5_EVENT_WAR_PACK_ENCODE_FAILURE_SET;	
unsigned char CRSEM_SERV5_EVENT_ERR_EEPROM_WRITE_ERROR_SET;		
unsigned char CRSEM_SERV5_EVENT_ERR_APS_BOOT_FAILURE_SET;		
unsigned char CRSEM_SERV5_EVENT_ERR_UNEXPECTED_REBOOT_SET;		
unsigned char CRSEM_SERV5_EVENT_ERR_WATCHDOG_FAILURE_SET;		
unsigned char CRSEM_SERV5_EVENT_ERR_CMD_SPW_RX_ERROR_SET;		
unsigned char CRSEM_SERV5_EVENT_ERR_EEPROM_EXE_SEG_COPY_ABORT_SET;	
unsigned char CRSEM_SERV5_EVENT_ERR_EEPROM_EXE_SEG_CRC_WRONG_SET;	
unsigned char CRSEM_SERV5_EVENT_ERR_EEPROM_PBS_CFG_SIZE_WRONG_SET;	
unsigned char CRSEM_SERV5_EVENT_ERR_WRITING_REGISTER_FAILED_SET;	
unsigned char CRSEM_SERV5_EVENT_ERR_CMD_BUFFER_1_FULL_SET;		
unsigned char CRSEM_SERV5_EVENT_ERR_CMD_BUFFER_2_FULL_SET;		
unsigned char CRSEM_SERV5_EVENT_ERR_DMA_DATA_TRANSF_FAIL_SET;
unsigned char CRSEM_SERV5_EVENT_ERR_DATA_BIAS_VOLT_WRONG_SET;
unsigned char CRSEM_SERV5_EVENT_ERR_FEESCU_SYNC_FAIL_SET;
unsigned char CRSEM_SERV5_EVENT_ERR_FEE_SCRIPT_ERROR_SET;
unsigned char CRSEM_SERV5_EVENT_ERR_SCU_POWER_SWITCH_FAIL_SET;
unsigned char CRSEM_SERV5_EVENT_ERR_SPW_TIME_CODE_MISS_SET;


/**
 * Clear all SEM event flags
 */
void CrIaClearSemEventFlags(void)
{
  CRSEM_SERV5_EVENT_PRG_PBS_BOOT_READY_SET = 0;
  CRSEM_SERV5_EVENT_PRG_APS_BOOT_READY_SET = 0; /* see Mantis 1178 */
  CRSEM_SERV5_EVENT_PRG_MODE_TRANSITION_SET = 0;
  CRSEM_SERV5_EVENT_PRG_DIAGNOSE_STEP_FINISHED_SET = 0;		
  CRSEM_SERV5_EVENT_PRG_THERMAL_STABILITY_SET = 0;		
  CRSEM_SERV5_EVENT_PRG_CFG_LOAD_READY_SET = 0; /* see Mantis 1178 */
  CRSEM_SERV5_EVENT_PRG_FPA_TEMP_NOMINAL_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_EEPROM_NO_SEGMENT_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_EEPROM_NO_APS_EXE_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_EEPROM_NO_APS_CFG_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_EEPROM_NO_PBS_CFG_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_EEPROM_NO_APS_EXE_FLAG_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_EEPROM_NO_APS_CFG_FLAG_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_NO_THERMAL_STABILITY_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_FPA_TEMP_TOO_HIGH_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_WRONG_EXPOSURE_TIME_SET = 0;		
  CRSEM_SERV5_EVENT_WAR_WRONG_REPETITION_PERIOD_SET = 0;
  CRSEM_SERV5_EVENT_WAR_FPM_OFF_ONLY_PATTERN_SET = 0;
  CRSEM_SERV5_EVENT_WAR_PACK_ENCODE_FAILURE_SET = 0;
  CRSEM_SERV5_EVENT_ERR_EEPROM_WRITE_ERROR_SET = 0;		
  CRSEM_SERV5_EVENT_ERR_APS_BOOT_FAILURE_SET = 0;		
  CRSEM_SERV5_EVENT_ERR_UNEXPECTED_REBOOT_SET = 0;		
  CRSEM_SERV5_EVENT_ERR_WATCHDOG_FAILURE_SET = 0;		
  CRSEM_SERV5_EVENT_ERR_CMD_SPW_RX_ERROR_SET = 0;		
  CRSEM_SERV5_EVENT_ERR_EEPROM_EXE_SEG_COPY_ABORT_SET = 0;	
  CRSEM_SERV5_EVENT_ERR_EEPROM_EXE_SEG_CRC_WRONG_SET = 0;	
  CRSEM_SERV5_EVENT_ERR_EEPROM_PBS_CFG_SIZE_WRONG_SET = 0;	
  CRSEM_SERV5_EVENT_ERR_WRITING_REGISTER_FAILED_SET = 0;	
  CRSEM_SERV5_EVENT_ERR_CMD_BUFFER_1_FULL_SET = 0;		
  CRSEM_SERV5_EVENT_ERR_CMD_BUFFER_2_FULL_SET = 0;		
  CRSEM_SERV5_EVENT_ERR_DMA_DATA_TRANSF_FAIL_SET = 0;
  CRSEM_SERV5_EVENT_ERR_DATA_BIAS_VOLT_WRONG_SET = 0;
  CRSEM_SERV5_EVENT_ERR_FEESCU_SYNC_FAIL_SET = 0;
  CRSEM_SERV5_EVENT_ERR_FEE_SCRIPT_ERROR_SET = 0;
  CRSEM_SERV5_EVENT_ERR_SCU_POWER_SWITCH_FAIL_SET = 0;
  CRSEM_SERV5_EVENT_ERR_SPW_TIME_CODE_MISS_SET = 0;
  
  return;
}
